org.apache.commons.math.linear

## Interface FieldLUDecomposition<T extends FieldElement<T>>

- Type Parameters:
    `T` - the type of the field elements
  All Known Implementing Classes:
    FieldLUDecompositionImpl

      public interface FieldLUDecomposition<T extends FieldElement<T>>

  An interface to classes that implement an algorithm to calculate the LU-decomposition of a real matrix.

  The LU-decomposition of matrix A is a set of three matrices: P, L and U such that P×A = L×U. P is a rows permutation matrix that is used to rearrange the rows of A before so that it can be decomposed. L is a lower triangular matrix with unit diagonal terms and U is an upper triangular matrix.

  This interface is based on the class with similar name from the JAMA library.

  - a `getP` method has been added,
  - the `det` method has been renamed as `getDeterminant`,
  - the `getDoublePivot` method has been removed (but the int based `getPivot` method has been kept),
  - the `solve` and `isNonSingular` methods have been replaced by a `getSolver` method and the equivalent methods provided by the returned `DecompositionSolver`.
  Since:
    2.0
  Version:
    $Revision: 826627 $ $Date: 2009-10-19 12:27:47 +0200 (lun. 19 oct. 2009) $
  See Also:
    MathWorld, Wikipedia

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `getDeterminant()` Return the determinant of the matrix
    `FieldMatrix<T>` | `getL()` Returns the matrix L of the decomposition.
    `FieldMatrix<T>` | `getP()` Returns the P rows permutation matrix.
    `int[]` | `getPivot()` Returns the pivot permutation vector.
    `FieldDecompositionSolver<T>` | `getSolver()` Get a solver for finding the A × X = B solution in exact linear sense.
    `FieldMatrix<T>` | `getU()` Returns the matrix U of the decomposition.

- - ### Method Detail

    - #### getL

          FieldMatrix<T> getL()

      Returns the matrix L of the decomposition.

      L is an lower-triangular matrix

      Returns:
        the L matrix (or null if decomposed matrix is singular)

    - #### getU

          FieldMatrix<T> getU()

      Returns the matrix U of the decomposition.

      U is an upper-triangular matrix

      Returns:
        the U matrix (or null if decomposed matrix is singular)

    - #### getP

          FieldMatrix<T> getP()

      Returns the P rows permutation matrix.

      P is a sparse matrix with exactly one element set to 1.0 in each row and each column, all other elements being set to 0.0.

      The positions of the 1 elements are given by the `pivot permutation vector`.

      Returns:
        the P rows permutation matrix (or null if decomposed matrix is singular)
      See Also:
        `getPivot()`

    - #### getPivot

          int[] getPivot()

      Returns the pivot permutation vector.
      Returns:
        the pivot permutation vector
      See Also:
        `getP()`

    - #### getDeterminant

          T getDeterminant()

      Return the determinant of the matrix
      Returns:
        determinant of the matrix

    - #### getSolver

          FieldDecompositionSolver<T> getSolver()

      Get a solver for finding the A × X = B solution in exact linear sense.
      Returns:
        a solver

Copyright (c) 2003-2013 Apache Software Foundation